"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var types_1 = require("./util/types");
var utilResponsive_1 = require("./util/utilResponsive");
var ids_1 = require("./util/ids");
var _a = utilResponsive_1.getWindowDimension(), width = _a.width, height = _a.height;
var initialState = { width: width, height: height };
var Responsive = /** @class */ (function (_super) {
    __extends(Responsive, _super);
    function Responsive() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = initialState;
        _this.handleResize = function () {
            var dimension = utilResponsive_1.getWindowDimension();
            _this.setState(__assign({}, dimension));
        };
        _this.render = function () {
            var children = _this.props.children;
            var _a = _this.state, width = _a.width, height = _a.height;
            var shouldRenderChildren = shouldRender(_this.getDisplayInArray(), width, height);
            return (React.createElement(React.Fragment, null, shouldRenderChildren ? children : null));
        };
        _this.getDisplayInArray = function () {
            var displayIn = _this.props.displayIn;
            return Array.isArray(displayIn) ? displayIn : [displayIn];
        };
        return _this;
    }
    Responsive.prototype.componentDidMount = function () {
        window.addEventListener('resize', this.handleResize, false);
    };
    Responsive.prototype.componentWillUnmount = function () {
        window.removeEventListener('resize', this.handleResize, false);
    };
    return Responsive;
}(React.PureComponent));
exports.Responsive = Responsive;
var shouldRender = function (display, width, height) {
    if (display.indexOf(types_1.IdResponsiveRenderOnlyIn.Laptop) !== -1 && width >= ids_1.IdDeviceBreakpointsByWidth.laptop_min) {
        return true;
    }
    if (display.indexOf(types_1.IdResponsiveRenderOnlyIn.Tablet) !== -1 && (width <= ids_1.IdDeviceBreakpointsByWidth.tablet_max && width >= ids_1.IdDeviceBreakpointsByWidth.tablet_min)) {
        return true;
    }
    // For mobile regardless of orientation
    if (display.indexOf(types_1.IdResponsiveRenderOnlyIn.Mobile) !== -1 && width <= ids_1.IdDeviceBreakpointsByWidth.mobile_max) {
        return true;
    }
    if (display.indexOf(types_1.IdResponsiveRenderOnlyIn.MobilePortrait) !== -1 && (width <= ids_1.IdDeviceBreakpointsByWidth.mobile_max && height >= ids_1.IdMobileHeight.mobileLandscape_max)) {
        return true;
    }
    return !!(display.indexOf(types_1.IdResponsiveRenderOnlyIn.MobileLandScape) !== -1 && (width <= ids_1.IdDeviceBreakpointsByWidth.mobile_max && height <= ids_1.IdMobileHeight.mobileLandscape_min));
};
//# sourceMappingURL=index.js.map